 
GO
/****** Object:  UserDefinedFunction [dbo].[SplitString]    Script Date: 6/29/2019 9:45:20 PM ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO


-- =============================================
CREATE FUNCTION [dbo].[SplitString] 
( @vcDelimitedString NVARCHAR(MAX), 
  @vcDelimiter NVARCHAR(10)) 
  RETURNS @tblArray TABLE    
    (   
      ElementID INT  IDENTITY(1,1)   ,
      Element VARCHAR(MAX)   
    ) AS BEGIN 
  DECLARE @siIndex SMALLINT, @siStart SMALLINT, @siDelSize SMALLINT
  SET @siDelSize      = LEN(@vcDelimiter)     
  WHILE LEN(@vcDelimitedString) > 0     
  BEGIN         
  SET @siIndex = CHARINDEX(@vcDelimiter, @vcDelimitedString)   
      IF @siIndex = 0  
        BEGIN   
         INSERT INTO @tblArray VALUES(@vcDelimitedString)      
   BREAK
     END     
         ELSE        
        BEGIN               
            INSERT INTO @tblArray VALUES(SUBSTRING(@vcDelimitedString, 1,@siIndex - 1))           
            SET @siStart = @siIndex + @siDelSize               
            SET @vcDelimitedString = SUBSTRING(@vcDelimitedString, @siStart , LEN(@vcDelimitedString) - @siStart + 1)        
          END    
         END     
      RETURN END



GO
/****** Object:  StoredProcedure [dbo].[GetCountryRegion]    Script Date: 6/29/2019 9:45:20 PM ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
  CREATE PROCEDURE [dbo].[GetCountryRegion]
  AS
     SELECT NULL CountryRegionCode, 'All'  EnglishCountryRegionName -- ALL MEMBER
	 UNION ALL
  SELECT DISTINCT  CountryRegionCode,EnglishCountryRegionName
    FROM dbo.DimGeography
GO
/****** Object:  StoredProcedure [dbo].[GETData]    Script Date: 6/29/2019 9:45:20 PM ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [dbo].[GETData]

@OrderDateKey INT , @OrderDateKey2 INT,
@CountryRegion VARCHAR(2),
@Province VARCHAR(MAX)

AS 
SELECT
  DimCustomer.FirstName
  ,DimCustomer.LastName
  ,DimCustomer.MiddleName
  ,DimCustomer.Gender
  ,DimCustomer.AddressLine1
  ,SUM(FactInternetSales.SalesAmount) AS Sum_SalesAmount
  ,SUM(FactInternetSales.OrderQuantity) AS Sum_OrderQuantity
  ,DimGeography.City
  ,DimGeography.StateProvinceName
  ,DimGeography.EnglishCountryRegionName
FROM
  DimCustomer
  INNER JOIN DimGeography
    ON DimCustomer.GeographyKey = DimGeography.GeographyKey
  INNER JOIN FactInternetSales
    ON DimCustomer.CustomerKey = FactInternetSales.CustomerKey
	JOIN dbo.SplitString(@Province,';') tmp ON tmp.Element  =DimGeography.StateProvinceCode
WHERE
  FactInternetSales.OrderDateKey >= @OrderDateKey
  AND FactInternetSales.OrderDateKey <= @OrderDateKey2
 
  AND ISNULL(@CountryRegion ,DimGeography.CountryRegionCode )= DimGeography.CountryRegionCode
  
GROUP BY
  DimCustomer.FirstName
  ,DimCustomer.LastName
  ,DimCustomer.MiddleName
  ,DimCustomer.Gender
  ,DimCustomer.AddressLine1
  ,DimGeography.City
  ,DimGeography.StateProvinceName
  ,DimGeography.EnglishCountryRegionName
  

GO
/****** Object:  StoredProcedure [dbo].[GetProvince]    Script Date: 6/29/2019 9:45:20 PM ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
	CREATE PROCEDURE [dbo].[GetProvince]
	@RegionCode VARCHAR(2)
	AS

	
   
  SELECT DISTINCT  StateProvinceCode,StateProvinceName
    FROM dbo.DimGeography
 WHERE ISNULL( @RegionCode,CountryRegionCode  )  =  CountryRegionCode  

GO
